blob: b47d51e7594547df8e461c089ab8de45961cf9ae [file] [log] [blame]
Ollie Lho184a4042005-11-26 21:55:36 +00001#
Uwe Hermannf78cff12009-06-12 14:05:25 +00002# This file is part of the flashrom project.
3#
4# Copyright (C) 2005 coresystems GmbH <stepan@coresystems.de>
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +00005# Copyright (C) 2009,2010,2012 Carl-Daniel Hailfinger
Uwe Hermannf78cff12009-06-12 14:05:25 +00006#
7# This program is free software; you can redistribute it and/or modify
8# it under the terms of the GNU General Public License as published by
9# the Free Software Foundation; version 2 of the License.
10#
11# This program is distributed in the hope that it will be useful,
12# but WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14# GNU General Public License for more details.
15#
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +000016
Thomas Heijligen90fa8152021-09-25 13:39:42 +020017include Makefile.include
18
Ollie Lho184a4042005-11-26 21:55:36 +000019PROGRAM = flashrom
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +000020
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000021###############################################################################
22# Defaults for the toolchain.
23
24# If you want to cross-compile, just run e.g.
25# make CC=i586-pc-msdosdjgpp-gcc
26# You may have to specify STRIP/AR/RANLIB as well.
Carl-Daniel Hailfingerb7bce8a2012-08-14 21:36:11 +000027#
28# Note for anyone editing this Makefile: gnumake will happily ignore any
29# changes in this Makefile to variables set on the command line.
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +000030STRIP ?= strip
Thomas Heijligenf579bba2021-10-12 12:48:01 +020031STRIP_ARGS = -s
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000032INSTALL = install
Paul Fox05dfbe62009-06-16 21:08:06 +000033DIFF = diff
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000034PREFIX ?= /usr/local
Uwe Hermann56b2cb02009-05-21 15:59:58 +000035MANDIR ?= $(PREFIX)/share/man
Nico Huber9e2dc2f2018-12-23 22:00:47 +010036CFLAGS ?= -Os -Wall -Wextra -Wno-unused-parameter -Wshadow -Wmissing-prototypes -Wwrite-strings
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +000037EXPORTDIR ?= .
Patrick Georgi97bc95c2011-03-08 07:17:44 +000038RANLIB ?= ranlib
Stefan Tauner3f73ffe2016-01-07 17:45:59 +000039PKG_CONFIG ?= pkg-config
40BUILD_DETAILS_FILE ?= build_details.txt
Stefan Taunerbe62d3f2015-01-10 09:32:44 +000041
Stefan Taunerfd0d4132012-09-25 21:24:55 +000042# The following parameter changes the default programmer that will be used if there is no -p/--programmer
43# argument given when running flashrom. The predefined setting does not enable any default so that every
44# user has to declare the programmer he wants to use on every run. The rationale for this to be not set
45# (to e.g. the internal programmer) is that forgetting to specify this when working with another programmer
46# easily puts the system attached to the default programmer at risk (e.g. you want to flash coreboot to another
47# system attached to an external programmer while the default programmer is set to the internal programmer, and
48# you forget to use the -p parameter. This would (try to) overwrite the existing firmware of the computer
49# running flashrom). Please do not enable this without thinking about the possible consequences. Possible
Thomas Heijligen84e9c912021-06-01 16:22:14 +020050# values can be found when running 'flashrom --list-supported' under the 'Supported programmers' section.
51CONFIG_DEFAULT_PROGRAMMER_NAME ?=
Stefan Tauner265fcac2014-06-02 00:12:23 +000052# The following adds a default parameter for the default programmer set above (only).
Thomas Heijligen84e9c912021-06-01 16:22:14 +020053CONFIG_DEFAULT_PROGRAMMER_ARGS ?=
Stefan Tauner265fcac2014-06-02 00:12:23 +000054# Example: compiling with
Thomas Heijligen84e9c912021-06-01 16:22:14 +020055# make CONFIG_DEFAULT_PROGRAMMER_NAME=serprog CONFIG_DEFAULT_PROGRAMMER_ARGS="dev=/dev/ttyUSB0:1500000"
Stefan Tauner265fcac2014-06-02 00:12:23 +000056# would make executing './flashrom' (almost) equivialent to './flashrom -p serprog:dev=/dev/ttyUSB0:1500000'.
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000057
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000058# If your compiler spits out excessive warnings, run make WARNERROR=no
59# You shouldn't have to change this flag.
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +000060WARNERROR ?= yes
61
62ifeq ($(WARNERROR), yes)
63CFLAGS += -Werror
64endif
65
Stefan Taunere37735a2015-01-26 22:03:35 +000066ifdef LIBS_BASE
Stefan Taunere37735a2015-01-26 22:03:35 +000067PKG_CONFIG_LIBDIR ?= $(LIBS_BASE)/lib/pkgconfig
Stefan Tauner45207062016-02-19 08:17:24 +000068override CPPFLAGS += -I$(LIBS_BASE)/include
69override LDFLAGS += -L$(LIBS_BASE)/lib -Wl,-rpath -Wl,$(LIBS_BASE)/lib
Stefan Taunere37735a2015-01-26 22:03:35 +000070endif
Stefan Taunerbe62d3f2015-01-10 09:32:44 +000071
Stefan Taunerbfb067b2016-01-07 18:13:07 +000072ifeq ($(CONFIG_STATIC),yes)
Stefan Tauner45207062016-02-19 08:17:24 +000073override PKG_CONFIG += --static
74override LDFLAGS += -static
Stefan Taunerbfb067b2016-01-07 18:13:07 +000075endif
76
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000077# Set LC_ALL=C to minimize influences of the locale.
78# However, this won't work for the majority of relevant commands because they use the $(shell) function and
Martin Rothf6c1cb12022-03-15 10:55:25 -060079# GNU make does not relay variables exported within the makefile to their environment.
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000080LC_ALL=C
81export LC_ALL
82
Stefan Tauner3f73ffe2016-01-07 17:45:59 +000083dummy_for_make_3_80:=$(shell printf "Build started on %s\n\n" "$$(date)" >$(BUILD_DETAILS_FILE))
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000084
85# Provide an easy way to execute a command, print its output to stdout and capture any error message on stderr
86# in the build details file together with the original stdout output.
Pyry Kontio89cc73b2020-07-06 12:57:35 +090087debug_shell = $(shell export LC_ALL=C ; { echo 'exec: export LC_ALL=C ; { $(subst ','\'',$(1)) ; }' >&2; \
88 { $(1) ; } | tee -a $(BUILD_DETAILS_FILE) ; echo >&2 ; } 2>>$(BUILD_DETAILS_FILE))
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000089
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000090###############################################################################
Nico Huber7f898972021-06-27 13:30:50 +020091# Dependency handling.
92
93DEPENDS_ON_SERIAL := \
94 CONFIG_BUSPIRATE_SPI \
95 CONFIG_PONY_SPI \
96 CONFIG_SERPROG \
97
98DEPENDS_ON_BITBANG_SPI := \
Nico Huber29c68342021-06-27 14:34:16 +020099 CONFIG_DEVELOPERBOX_SPI \
Nico Huber7f898972021-06-27 13:30:50 +0200100 CONFIG_INTERNAL \
101 CONFIG_NICINTEL_SPI \
102 CONFIG_OGP_SPI \
103 CONFIG_PONY_SPI \
104 CONFIG_RAYER_SPI \
105
106DEPENDS_ON_LIBPCI := \
107 CONFIG_ATAHPT \
108 CONFIG_ATAPROMISE \
109 CONFIG_ATAVIA \
110 CONFIG_DRKAISER \
111 CONFIG_GFXNVIDIA \
112 CONFIG_INTERNAL \
113 CONFIG_IT8212 \
114 CONFIG_NIC3COM \
115 CONFIG_NICINTEL \
116 CONFIG_NICINTEL_EEPROM \
117 CONFIG_NICINTEL_SPI \
118 CONFIG_NICNATSEMI \
119 CONFIG_NICREALTEK \
120 CONFIG_OGP_SPI \
121 CONFIG_SATAMV \
122 CONFIG_SATASII \
123
124DEPENDS_ON_LIBUSB1 := \
125 CONFIG_CH341A_SPI \
126 CONFIG_DEDIPROG \
127 CONFIG_DEVELOPERBOX_SPI \
128 CONFIG_DIGILENT_SPI \
129 CONFIG_PICKIT2_SPI \
130 CONFIG_RAIDEN_DEBUG_SPI \
131 CONFIG_STLINKV3_SPI \
Jean THOMASe28d8e42022-10-11 17:54:30 +0200132 CONFIG_DIRTYJTAG_SPI \
Nico Huber7f898972021-06-27 13:30:50 +0200133
134DEPENDS_ON_LIBFTDI := \
135 CONFIG_FT2232_SPI \
136 CONFIG_USBBLASTER_SPI \
137
138DEPENDS_ON_LIBJAYLINK := \
139 CONFIG_JLINK_SPI \
140
Nico Hubera54f5a42021-06-27 14:27:41 +0200141
142ifeq ($(CONFIG_ENABLE_LIBUSB1_PROGRAMMERS), no)
143$(call disable_all,$(DEPENDS_ON_LIBUSB1))
144endif
145
146ifeq ($(CONFIG_ENABLE_LIBPCI_PROGRAMMERS), no)
147$(call disable_all,$(DEPENDS_ON_LIBPCI))
148endif
149
Nico Huber7f898972021-06-27 13:30:50 +0200150###############################################################################
Stefan Tauner037cd842013-08-25 00:10:56 +0000151# General OS-specific settings.
152# 1. Prepare for later by gathering information about host and target OS
153# 2. Set compiler flags and parameters according to OSes
154# 3. Likewise verify user-supplied CONFIG_* variables.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000155
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000156# HOST_OS is only used to work around local toolchain issues.
Stefan Tauner037cd842013-08-25 00:10:56 +0000157HOST_OS ?= $(shell uname)
Miklós Mártona75a2ed2018-01-30 20:25:00 +0100158ifeq ($(findstring MINGW, $(HOST_OS)), MINGW)
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000159# Explicitly set CC = gcc on MinGW, otherwise: "cc: command not found".
160CC = gcc
161endif
Miklós Mártona75a2ed2018-01-30 20:25:00 +0100162
Thomas Heijligen282a9512021-10-12 13:30:06 +0200163# Determine the destination OS, architecture and endian
164# IMPORTANT: The following lines must be placed before TARGET_OS, ARCH or ENDIAN
165# is ever used (of course), but should come after any lines setting CC because
166# the lines below use CC itself.
Thomas Heijligen1e76dc82021-09-28 15:22:34 +0200167override TARGET_OS := $(call c_macro_test, Makefile.d/os_test.h)
Thomas Heijligen282a9512021-10-12 13:30:06 +0200168override ARCH := $(strip $(call debug_shell,$(CC) $(CPPFLAGS) -E archtest.c 2>/dev/null \
169 | tail -1 | cut -f 2 -d'"'))
170override ENDIAN := $(strip $(call debug_shell,$(CC) $(CPPFLAGS) -E endiantest.c 2>/dev/null \
171 | tail -1))
172
Thomas Heijligen0bec7b22021-10-12 13:18:15 +0200173ifeq ($(TARGET_OS), $(filter $(TARGET_OS), FreeBSD OpenBSD DragonFlyBSD))
174override CPPFLAGS += -I/usr/local/include
175override LDFLAGS += -L/usr/local/lib
176endif
177
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000178ifeq ($(TARGET_OS), Darwin)
Stefan Tauner45207062016-02-19 08:17:24 +0000179override CPPFLAGS += -I/opt/local/include -I/usr/local/include
180override LDFLAGS += -L/opt/local/lib -L/usr/local/lib
Stefan Reinauerf79edb92009-01-26 01:23:31 +0000181endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000182
Stefan Taunerc65b8552013-09-12 15:48:39 +0000183ifeq ($(TARGET_OS), NetBSD)
Nico Huberc0e1c4b2022-12-13 21:55:22 +0000184# Needs special `pciutils/pci.h` for older NetBSD packages
185PCIUTILS_PCI_H := $(shell [ -f /usr/pkg/include/pciutils/pci.h ] && echo -DPCIUTILS_PCI_H)
186override CPPFLAGS += -I/usr/pkg/include $(PCIUTILS_PCI_H)
Stefan Tauner45207062016-02-19 08:17:24 +0000187override LDFLAGS += -L/usr/pkg/lib
Stefan Taunerc65b8552013-09-12 15:48:39 +0000188endif
189
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000190ifeq ($(TARGET_OS), DOS)
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000191EXEC_SUFFIX := .exe
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000192# DJGPP has odd uint*_t definitions which cause lots of format string warnings.
Stefan Tauner45207062016-02-19 08:17:24 +0000193override CFLAGS += -Wno-format
Stefan Tauner449abe22013-09-11 23:34:57 +0000194LIBS += -lgetopt
Nico Huberba681962021-06-27 13:39:23 +0200195# Missing serial support.
196$(call mark_unsupported,$(DEPENDS_ON_SERIAL))
197# Libraries not available for DOS
198$(call mark_unsupported,$(DEPENDS_ON_LIBUSB1) $(DEPENDS_ON_LIBFTDI) $(DEPENDS_ON_LIBJAYLINK))
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000199endif
Ollie Lho184a4042005-11-26 21:55:36 +0000200
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000201# FIXME: Should we check for Cygwin/MSVC as well?
202ifeq ($(TARGET_OS), MinGW)
203EXEC_SUFFIX := .exe
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000204# MinGW doesn't have the ffs() function, but we can use gcc's __builtin_ffs().
Carl-Daniel Hailfingera8da2242012-08-15 23:06:32 +0000205FLASHROM_CFLAGS += -Dffs=__builtin_ffs
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000206# Some functions provided by Microsoft do not work as described in C99 specifications. This macro fixes that
Stefan Tauner23e10b82016-01-23 16:16:49 +0000207# for MinGW. See http://sourceforge.net/p/mingw-w64/wiki2/printf%20and%20scanf%20family/ */
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000208FLASHROM_CFLAGS += -D__USE_MINGW_ANSI_STDIO=1
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100209
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000210# For now we disable all PCI-based programmers on Windows/MinGW (no libpci).
Nico Huberca621782021-06-27 13:53:49 +0200211$(call mark_unsupported,$(DEPENDS_ON_LIBPCI))
212# And programmers that need raw access.
213$(call mark_unsupported,CONFIG_RAYER_SPI)
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000214
Nico Huberca621782021-06-27 13:53:49 +0200215else # No MinGW
216
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100217# NI USB-845x only supported on Windows at the moment
Nico Huberca621782021-06-27 13:53:49 +0200218$(call mark_unsupported,CONFIG_NI845X_SPI)
219
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100220endif
221
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000222ifeq ($(TARGET_OS), libpayload)
Stefan Tauner8e19b042013-08-28 09:55:04 +0000223ifeq ($(MAKECMDGOALS),)
224.DEFAULT_GOAL := libflashrom.a
225$(info Setting default goal to libflashrom.a)
226endif
Carl-Daniel Hailfingera8da2242012-08-15 23:06:32 +0000227FLASHROM_CFLAGS += -DSTANDALONE
Nico Huber71331032021-06-27 14:00:39 +0200228$(call mark_unsupported,CONFIG_DUMMY)
Stefan Taunere0168262016-02-21 11:18:24 +0000229# libpayload does not provide the romsize field in struct pci_dev that the atapromise code requires.
Nico Huber71331032021-06-27 14:00:39 +0200230$(call mark_unsupported,CONFIG_ATAPROMISE)
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000231# Bus Pirate, Serprog and PonyProg are not supported with libpayload (missing serial support).
Nico Huber71331032021-06-27 14:00:39 +0200232$(call mark_unsupported,CONFIG_BUSPIRATE_SPI CONFIG_SERPROG CONFIG_PONY_SPI)
Daniel Thompson45e91a22018-06-04 13:46:29 +0100233# Dediprog, Developerbox, USB-Blaster, PICkit2, CH341A and FT2232 are not supported with libpayload (missing libusb support).
Nico Huber71331032021-06-27 14:00:39 +0200234$(call mark_unsupported,$(DEPENDS_ON_LIBUSB1) $(DEPENDS_ON_LIBFTDI) $(DEPENDS_ON_LIBJAYLINK))
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000235endif
236
Nico Huberdc8e54a2021-06-27 14:17:34 +0200237# Android is handled internally as separate OS, but it supports about the same drivers as Linux.
238ifeq ($(filter $(TARGET_OS),Linux Android), )
239$(call mark_unsupported,CONFIG_LINUX_MTD CONFIG_LINUX_SPI)
240$(call mark_unsupported,CONFIG_MSTARDDC_SPI)
Carl-Daniel Hailfinger601f4cd2016-02-28 22:04:51 +0000241endif
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000242
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000243ifeq ($(TARGET_OS), Android)
Nico Huberdc8e54a2021-06-27 14:17:34 +0200244# Android on x86 (currently) does not provide raw PCI port I/O operations.
245$(call mark_unsupported,CONFIG_RAYER_SPI)
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000246endif
247
Nico Huberc8801732017-12-01 18:19:43 +0000248# Disable the internal programmer on unsupported architectures (everything but x86 and mipsel)
249ifneq ($(ARCH)-little, $(filter $(ARCH),x86 mips)-$(ENDIAN))
Nico Huber8945b812021-06-27 14:24:53 +0200250$(call mark_unsupported,CONFIG_INTERNAL)
Nico Huberc8801732017-12-01 18:19:43 +0000251endif
252
Stefan Taunerfb2d77c2015-02-10 08:03:10 +0000253# PCI port I/O support is unimplemented on PPC/MIPS/SPARC and unavailable on ARM.
David Hendricksb286da72012-02-13 00:35:35 +0000254# Right now this means the drivers below only work on x86.
255ifneq ($(ARCH), x86)
Nico Huber8945b812021-06-27 14:24:53 +0200256$(call mark_unsupported,CONFIG_NIC3COM CONFIG_NICREALTEK CONFIG_NICNATSEMI)
257$(call mark_unsupported,CONFIG_RAYER_SPI CONFIG_ATAHPT CONFIG_ATAPROMISE)
258$(call mark_unsupported,CONFIG_SATAMV)
Uwe Hermann21b10c62011-07-29 12:13:01 +0000259endif
260
Nico Huber8945b812021-06-27 14:24:53 +0200261# Additionally disable all drivers needing raw access (memory, PCI, port I/O)
262# on architectures with unknown raw access properties.
Carl-Daniel Hailfinger8d0d53f2016-02-25 20:10:26 +0000263# Right now those architectures are alpha hppa m68k sh s390
Rosen Penev34d07f02019-07-02 00:14:01 -0700264ifneq ($(ARCH),$(filter $(ARCH),x86 mips ppc arm sparc arc))
Nico Huber8945b812021-06-27 14:24:53 +0200265$(call mark_unsupported,CONFIG_GFXNVIDIA CONFIG_SATASII CONFIG_ATAVIA)
266$(call mark_unsupported,CONFIG_DRKAISER CONFIG_NICINTEL CONFIG_NICINTEL_SPI)
267$(call mark_unsupported,CONFIG_NICINTEL_EEPROM CONFIG_OGP_SPI CONFIG_IT8212)
Carl-Daniel Hailfinger8d0d53f2016-02-25 20:10:26 +0000268endif
269
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000270###############################################################################
271# Flash chip drivers and bus support infrastructure.
272
Stefan Tauner4404f732013-09-12 08:28:56 +0000273CHIP_OBJS = jedec.o stm50.o w39.o w29ee011.o \
Carl-Daniel Hailfingera8cf3622014-08-08 08:33:01 +0000274 sst28sf040.o 82802ab.o \
Paul Kocialkowski80ae14e2018-01-15 01:07:46 +0300275 sst49lfxxxc.o sst_fwhub.o edi.o flashchips.o spi.o spi25.o spi25_statusreg.o \
Nikolai Artemievc9feb1b2021-10-21 01:35:13 +1100276 spi95.o opaque.o sfdp.o en29lv640b.o at45db.o \
277 writeprotect.o writeprotect_ranges.o
Sean Nelson5d134642009-12-24 16:54:21 +0000278
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000279###############################################################################
280# Library code.
Sean Nelson5d134642009-12-24 16:54:21 +0000281
Thomas Heijligenbbfacff2021-03-31 20:40:01 +0200282LIB_OBJS = libflashrom.o layout.o flashrom.o udelay.o programmer.o programmer_table.o helpers.o ich_descriptors.o fmap.o
Sean Nelson5d134642009-12-24 16:54:21 +0000283
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000284###############################################################################
285# Frontend related stuff.
Ollie Lho184a4042005-11-26 21:55:36 +0000286
Stefan Tauner9b32de92014-08-08 23:52:33 +0000287CLI_OBJS = cli_classic.o cli_output.o cli_common.o print.o
Ollie Lho184a4042005-11-26 21:55:36 +0000288
Stefan Taunerfa25bc32017-10-04 03:47:26 +0200289# versioninfo.inc stores metadata required to build a packaged flashrom. It is generated by the export rule and
290# imported below. If versioninfo.inc is not found and the variables are not defined by the user, the info will
291# be obtained using util/getrevision.sh, which is the common case during development.
292-include versioninfo.inc
Stefan Tauner5bf6b852017-10-04 03:46:51 +0200293VERSION ?= $(shell ./util/getrevision.sh --revision)
Stefan Tauner96209122017-10-01 16:41:35 +0200294MAN_DATE ?= $(shell ./util/getrevision.sh --date $(PROGRAM).8.tmpl 2>/dev/null)
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +0000295
Stefan Tauner76347082016-11-27 17:45:49 +0100296SCMDEF := -D'FLASHROM_VERSION="$(VERSION)"'
Bernhard Walle201bde32008-01-21 15:24:22 +0000297
Stefan Tauner76347082016-11-27 17:45:49 +0100298# Inform user of the version string
Nico Huber26c2c4d2023-01-10 17:45:38 +0100299ifeq ($(filter branch tag,$(MAKECMDGOALS)), )
Stefan Tauner76347082016-11-27 17:45:49 +0100300$(info Replacing all version templates with $(VERSION).)
Nico Huber26c2c4d2023-01-10 17:45:38 +0100301endif
Stefan Taunerd5ff8452015-01-10 09:32:07 +0000302
Stefan Tauner037cd842013-08-25 00:10:56 +0000303###############################################################################
304# Default settings of CONFIG_* variables.
305
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000306# Always enable internal/onboard support for now.
307CONFIG_INTERNAL ?= yes
308
Stefan Tauner52b6e9d2013-04-01 00:46:05 +0000309# Always enable serprog for now.
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000310CONFIG_SERPROG ?= yes
311
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000312# RayeR SPIPGM hardware support
313CONFIG_RAYER_SPI ?= yes
314
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000315# PonyProg2000 SPI hardware support
316CONFIG_PONY_SPI ?= yes
317
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000318# Always enable 3Com NICs for now.
319CONFIG_NIC3COM ?= yes
320
Carl-Daniel Hailfingerbf3af292010-07-29 14:41:46 +0000321# Enable NVIDIA graphics cards. Note: write and erase do not work properly.
322CONFIG_GFXNVIDIA ?= yes
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000323
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000324# Always enable SiI SATA controllers for now.
325CONFIG_SATASII ?= yes
326
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000327# Highpoint (HPT) ATA/RAID controller support.
328# IMPORTANT: This code is not yet working!
329CONFIG_ATAHPT ?= no
330
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000331# VIA VT6421A LPC memory support
332CONFIG_ATAVIA ?= yes
333
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000334# Promise ATA controller support.
335CONFIG_ATAPROMISE ?= no
336
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000337# Always enable FT2232 SPI dongles for now.
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000338CONFIG_FT2232_SPI ?= yes
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000339
James Lairdc60de0e2013-03-27 13:00:23 +0000340# Always enable Altera USB-Blaster dongles for now.
341CONFIG_USBBLASTER_SPI ?= yes
342
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000343# MSTAR DDC support needs more tests/reviews/cleanups.
344CONFIG_MSTARDDC_SPI ?= no
345
Justin Chevrier66e554b2015-02-08 21:58:10 +0000346# Always enable PICkit2 SPI dongles for now.
347CONFIG_PICKIT2_SPI ?= yes
348
Miklós Márton324929c2019-08-01 19:14:10 +0200349# Always enable STLink V3
350CONFIG_STLINKV3_SPI ?= yes
351
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000352# Always enable dummy tracing for now.
353CONFIG_DUMMY ?= yes
354
355# Always enable Dr. Kaiser for now.
356CONFIG_DRKAISER ?= yes
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000357
Joerg Fischer5665ef32010-05-21 21:54:07 +0000358# Always enable Realtek NICs for now.
359CONFIG_NICREALTEK ?= yes
360
Andrew Morganc29c2e72010-06-07 22:37:54 +0000361# Disable National Semiconductor NICs until support is complete and tested.
362CONFIG_NICNATSEMI ?= no
363
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000364# Always enable Intel NICs for now.
365CONFIG_NICINTEL ?= yes
366
Idwer Vollering004f4b72010-09-03 18:21:21 +0000367# Always enable SPI on Intel NICs for now.
368CONFIG_NICINTEL_SPI ?= yes
369
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000370# Always enable EEPROM on Intel NICs for now.
371CONFIG_NICINTEL_EEPROM ?= yes
372
Mark Marshall90021f22010-12-03 14:48:11 +0000373# Always enable SPI on OGP cards for now.
374CONFIG_OGP_SPI ?= yes
375
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000376# Always enable Bus Pirate SPI for now.
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000377CONFIG_BUSPIRATE_SPI ?= yes
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000378
Simon Glassae616512016-01-23 23:27:58 +0000379# Always enable Dediprog SF100 for now.
380CONFIG_DEDIPROG ?= yes
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000381
Daniel Thompson45e91a22018-06-04 13:46:29 +0100382# Always enable Developerbox emergency recovery for now.
383CONFIG_DEVELOPERBOX_SPI ?= yes
384
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000385# Always enable Marvell SATA controllers for now.
386CONFIG_SATAMV ?= yes
387
David Hendricksf9a30552015-05-23 20:30:30 -0700388# Enable Linux spidev and MTD interfaces by default. We disable them on non-Linux targets.
389CONFIG_LINUX_MTD ?= yes
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000390CONFIG_LINUX_SPI ?= yes
391
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000392# Always enable ITE IT8212F PATA controllers for now.
393CONFIG_IT8212 ?= yes
394
Urja Rannikko0870b022016-01-31 22:10:29 +0000395# Winchiphead CH341A
396CONFIG_CH341A_SPI ?= yes
397
Lubomir Rintelb2154e82018-01-14 17:35:33 +0100398# Digilent Development board JTAG
399CONFIG_DIGILENT_SPI ?= yes
400
Jean THOMASe28d8e42022-10-11 17:54:30 +0200401# DirtyJTAG
402CONFIG_DIRTYJTAG_SPI ?= yes
403
Marc Schink3578ec62016-03-17 16:23:03 +0100404# Disable J-Link for now.
405CONFIG_JLINK_SPI ?= no
406
Nico Huber83d52072021-06-27 00:07:13 +0200407# National Instruments USB-845x is Windows only and needs a proprietary library.
408CONFIG_NI845X_SPI ?= no
409
Carl-Daniel Hailfinger6161ff12009-11-16 21:22:24 +0000410# Disable wiki printing by default. It is only useful if you have wiki access.
Uwe Hermann2db77a02010-06-04 17:07:39 +0000411CONFIG_PRINT_WIKI ?= no
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +0000412
Stefan Taunerf3503372016-02-26 23:51:21 +0000413# Disable all features if CONFIG_NOTHING=yes is given unless CONFIG_EVERYTHING was also set
414ifeq ($(CONFIG_NOTHING), yes)
415 ifeq ($(CONFIG_EVERYTHING), yes)
416 $(error Setting CONFIG_NOTHING=yes and CONFIG_EVERYTHING=yes does not make sense)
417 endif
418 $(foreach var, $(filter CONFIG_%, $(.VARIABLES)),\
419 $(if $(filter yes, $($(var))),\
420 $(eval $(var)=no)))
421endif
422
Patrick Georgiced7ab62015-01-19 19:52:34 +0000423# Enable all features if CONFIG_EVERYTHING=yes is given
424ifeq ($(CONFIG_EVERYTHING), yes)
425$(foreach var, $(filter CONFIG_%, $(.VARIABLES)),\
426 $(if $(filter no, $($(var))),\
427 $(eval $(var)=yes)))
428endif
429
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000430# Bitbanging SPI infrastructure, default off unless needed.
Nico Huber29c68342021-06-27 14:34:16 +0200431
432ifneq ($(call filter_deps,$(DEPENDS_ON_BITBANG_SPI)), )
Felix Singer4cbc1cb2022-07-22 23:23:28 +0200433override CONFIG_BITBANG_SPI = yes
434else
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000435CONFIG_BITBANG_SPI ?= no
436endif
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000437
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000438###############################################################################
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000439# Handle CONFIG_* variables that depend on others set (and verified) above.
440
441# The external DMI decoder (dmidecode) does not work in libpayload. Bail out if the internal one got disabled.
442ifeq ($(TARGET_OS), libpayload)
443ifeq ($(CONFIG_INTERNAL), yes)
444ifeq ($(CONFIG_INTERNAL_DMI), no)
445UNSUPPORTED_FEATURES += CONFIG_INTERNAL_DMI=no
446else
447override CONFIG_INTERNAL_DMI = yes
448endif
449endif
450endif
451
452# Use internal DMI/SMBIOS decoder by default instead of relying on dmidecode.
453CONFIG_INTERNAL_DMI ?= yes
454
455###############################################################################
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000456# Programmer drivers and programmer support infrastructure.
Stefan Tauner037cd842013-08-25 00:10:56 +0000457# Depending on the CONFIG_* variables set and verified above we set compiler flags and parameters below.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000458
Thomas Heijligen84e9c912021-06-01 16:22:14 +0200459ifdef CONFIG_DEFAULT_PROGRAMMER_NAME
460FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_NAME=&programmer_$(CONFIG_DEFAULT_PROGRAMMER_NAME)'
461else
462FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_NAME=NULL'
463endif
464
Stefan Tauner265fcac2014-06-02 00:12:23 +0000465FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_ARGS="$(CONFIG_DEFAULT_PROGRAMMER_ARGS)"'
Stefan Taunerfd0d4132012-09-25 21:24:55 +0000466
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000467ifeq ($(CONFIG_INTERNAL), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000468FEATURE_CFLAGS += -D'CONFIG_INTERNAL=1'
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000469PROGRAMMER_OBJS += processor_enable.o chipset_enable.o board_enable.o cbtable.o internal.o
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000470ifeq ($(ARCH), x86)
Edward O'Callaghan2ab6bba2022-06-24 16:48:09 +1000471PROGRAMMER_OBJS += it87spi.o sb600spi.o amd_imc.o wbsio_spi.o mcp6x_spi.o
Nico Huber305f4172013-06-14 11:55:26 +0200472PROGRAMMER_OBJS += ichspi.o dmi.o
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000473ifeq ($(CONFIG_INTERNAL_DMI), yes)
474FEATURE_CFLAGS += -D'CONFIG_INTERNAL_DMI=1'
475endif
Carl-Daniel Hailfinger91199a12011-07-07 06:59:18 +0000476else
477endif
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000478endif
479
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000480ifeq ($(CONFIG_SERPROG), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000481FEATURE_CFLAGS += -D'CONFIG_SERPROG=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000482PROGRAMMER_OBJS += serprog.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000483NEED_SERIAL += CONFIG_SERPROG
484NEED_POSIX_SOCKETS += CONFIG_SERPROG
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000485endif
486
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000487ifeq ($(CONFIG_RAYER_SPI), yes)
488FEATURE_CFLAGS += -D'CONFIG_RAYER_SPI=1'
489PROGRAMMER_OBJS += rayer_spi.o
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000490NEED_RAW_ACCESS += CONFIG_RAYER_SPI
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000491endif
492
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000493ifeq ($(CONFIG_PONY_SPI), yes)
494FEATURE_CFLAGS += -D'CONFIG_PONY_SPI=1'
495PROGRAMMER_OBJS += pony_spi.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000496NEED_SERIAL += CONFIG_PONY_SPI
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000497endif
498
Carl-Daniel Hailfinger547872b2009-09-28 13:15:16 +0000499ifeq ($(CONFIG_BITBANG_SPI), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000500FEATURE_CFLAGS += -D'CONFIG_BITBANG_SPI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000501PROGRAMMER_OBJS += bitbang_spi.o
Carl-Daniel Hailfinger547872b2009-09-28 13:15:16 +0000502endif
503
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000504ifeq ($(CONFIG_NIC3COM), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000505FEATURE_CFLAGS += -D'CONFIG_NIC3COM=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000506PROGRAMMER_OBJS += nic3com.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000507endif
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000508
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000509ifeq ($(CONFIG_GFXNVIDIA), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000510FEATURE_CFLAGS += -D'CONFIG_GFXNVIDIA=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000511PROGRAMMER_OBJS += gfxnvidia.o
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000512endif
513
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000514ifeq ($(CONFIG_SATASII), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000515FEATURE_CFLAGS += -D'CONFIG_SATASII=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000516PROGRAMMER_OBJS += satasii.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000517endif
518
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000519ifeq ($(CONFIG_ATAHPT), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000520FEATURE_CFLAGS += -D'CONFIG_ATAHPT=1'
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000521PROGRAMMER_OBJS += atahpt.o
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000522endif
523
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000524ifeq ($(CONFIG_ATAVIA), yes)
525FEATURE_CFLAGS += -D'CONFIG_ATAVIA=1'
526PROGRAMMER_OBJS += atavia.o
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000527endif
528
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000529ifeq ($(CONFIG_ATAPROMISE), yes)
530FEATURE_CFLAGS += -D'CONFIG_ATAPROMISE=1'
531PROGRAMMER_OBJS += atapromise.o
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000532endif
533
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000534ifeq ($(CONFIG_IT8212), yes)
535FEATURE_CFLAGS += -D'CONFIG_IT8212=1'
536PROGRAMMER_OBJS += it8212.o
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000537endif
538
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000539ifeq ($(CONFIG_FT2232_SPI), yes)
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000540# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000541FEATURE_CFLAGS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "-D'CONFIG_FT2232_SPI=1'")
James Lairdc60de0e2013-03-27 13:00:23 +0000542PROGRAMMER_OBJS += ft2232_spi.o
543endif
544
545ifeq ($(CONFIG_USBBLASTER_SPI), yes)
546# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000547FEATURE_CFLAGS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "-D'CONFIG_USBBLASTER_SPI=1'")
James Lairdc60de0e2013-03-27 13:00:23 +0000548PROGRAMMER_OBJS += usbblaster_spi.o
549endif
550
Justin Chevrier66e554b2015-02-08 21:58:10 +0000551ifeq ($(CONFIG_PICKIT2_SPI), yes)
552FEATURE_CFLAGS += -D'CONFIG_PICKIT2_SPI=1'
553PROGRAMMER_OBJS += pickit2_spi.o
Justin Chevrier66e554b2015-02-08 21:58:10 +0000554endif
555
Miklós Márton324929c2019-08-01 19:14:10 +0200556ifeq ($(CONFIG_STLINKV3_SPI), yes)
557FEATURE_CFLAGS += -D'CONFIG_STLINKV3_SPI=1'
558PROGRAMMER_OBJS += stlinkv3_spi.o
Miklós Márton324929c2019-08-01 19:14:10 +0200559endif
560
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000561ifeq ($(CONFIG_DUMMY), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000562FEATURE_CFLAGS += -D'CONFIG_DUMMY=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000563PROGRAMMER_OBJS += dummyflasher.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000564endif
565
566ifeq ($(CONFIG_DRKAISER), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000567FEATURE_CFLAGS += -D'CONFIG_DRKAISER=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000568PROGRAMMER_OBJS += drkaiser.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000569endif
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000570
Joerg Fischer5665ef32010-05-21 21:54:07 +0000571ifeq ($(CONFIG_NICREALTEK), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000572FEATURE_CFLAGS += -D'CONFIG_NICREALTEK=1'
Joerg Fischer5665ef32010-05-21 21:54:07 +0000573PROGRAMMER_OBJS += nicrealtek.o
Joerg Fischer5665ef32010-05-21 21:54:07 +0000574endif
575
Andrew Morganc29c2e72010-06-07 22:37:54 +0000576ifeq ($(CONFIG_NICNATSEMI), yes)
577FEATURE_CFLAGS += -D'CONFIG_NICNATSEMI=1'
578PROGRAMMER_OBJS += nicnatsemi.o
Andrew Morganc29c2e72010-06-07 22:37:54 +0000579endif
580
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000581ifeq ($(CONFIG_NICINTEL), yes)
582FEATURE_CFLAGS += -D'CONFIG_NICINTEL=1'
583PROGRAMMER_OBJS += nicintel.o
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000584endif
585
Idwer Vollering004f4b72010-09-03 18:21:21 +0000586ifeq ($(CONFIG_NICINTEL_SPI), yes)
587FEATURE_CFLAGS += -D'CONFIG_NICINTEL_SPI=1'
588PROGRAMMER_OBJS += nicintel_spi.o
Idwer Vollering004f4b72010-09-03 18:21:21 +0000589endif
590
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000591ifeq ($(CONFIG_NICINTEL_EEPROM), yes)
592FEATURE_CFLAGS += -D'CONFIG_NICINTEL_EEPROM=1'
593PROGRAMMER_OBJS += nicintel_eeprom.o
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000594endif
595
Mark Marshall90021f22010-12-03 14:48:11 +0000596ifeq ($(CONFIG_OGP_SPI), yes)
597FEATURE_CFLAGS += -D'CONFIG_OGP_SPI=1'
598PROGRAMMER_OBJS += ogp_spi.o
Mark Marshall90021f22010-12-03 14:48:11 +0000599endif
600
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000601ifeq ($(CONFIG_BUSPIRATE_SPI), yes)
602FEATURE_CFLAGS += -D'CONFIG_BUSPIRATE_SPI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000603PROGRAMMER_OBJS += buspirate_spi.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000604NEED_SERIAL += CONFIG_BUSPIRATE_SPI
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000605endif
606
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000607ifeq ($(CONFIG_DEDIPROG), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000608FEATURE_CFLAGS += -D'CONFIG_DEDIPROG=1'
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000609PROGRAMMER_OBJS += dediprog.o
610endif
611
Daniel Thompson45e91a22018-06-04 13:46:29 +0100612ifeq ($(CONFIG_DEVELOPERBOX_SPI), yes)
613FEATURE_CFLAGS += -D'CONFIG_DEVELOPERBOX_SPI=1'
614PROGRAMMER_OBJS += developerbox_spi.o
Daniel Thompson45e91a22018-06-04 13:46:29 +0100615endif
616
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000617ifeq ($(CONFIG_SATAMV), yes)
618FEATURE_CFLAGS += -D'CONFIG_SATAMV=1'
619PROGRAMMER_OBJS += satamv.o
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000620endif
621
David Hendricksf9a30552015-05-23 20:30:30 -0700622ifeq ($(CONFIG_LINUX_MTD), yes)
623# This is a totally ugly hack.
624FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_MTD_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_LINUX_MTD=1'")
625PROGRAMMER_OBJS += linux_mtd.o
626endif
627
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000628ifeq ($(CONFIG_LINUX_SPI), yes)
Stefan Tauner8868db32012-03-13 00:18:19 +0000629# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000630FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_SPI_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_LINUX_SPI=1'")
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000631PROGRAMMER_OBJS += linux_spi.o
632endif
633
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000634ifeq ($(CONFIG_MSTARDDC_SPI), yes)
635# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000636FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_I2C_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_MSTARDDC_SPI=1'")
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000637NEED_LINUX_I2C += CONFIG_MSTARDDC_SPI
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000638PROGRAMMER_OBJS += mstarddc_spi.o
639endif
640
Urja Rannikko0870b022016-01-31 22:10:29 +0000641ifeq ($(CONFIG_CH341A_SPI), yes)
642FEATURE_CFLAGS += -D'CONFIG_CH341A_SPI=1'
643PROGRAMMER_OBJS += ch341a_spi.o
Urja Rannikko0870b022016-01-31 22:10:29 +0000644endif
645
Lubomir Rintelb2154e82018-01-14 17:35:33 +0100646ifeq ($(CONFIG_DIGILENT_SPI), yes)
647FEATURE_CFLAGS += -D'CONFIG_DIGILENT_SPI=1'
648PROGRAMMER_OBJS += digilent_spi.o
Lubomir Rintelb2154e82018-01-14 17:35:33 +0100649endif
650
Jean THOMASe28d8e42022-10-11 17:54:30 +0200651ifeq ($(CONFIG_DIRTYJTAG_SPI), yes)
652FEATURE_CFLAGS += -D'CONFIG_DIRTYJTAG_SPI=1'
653PROGRAMMER_OBJS += dirtyjtag_spi.o
654endif
655
Marc Schink3578ec62016-03-17 16:23:03 +0100656ifeq ($(CONFIG_JLINK_SPI), yes)
Marc Schink3578ec62016-03-17 16:23:03 +0100657FEATURE_CFLAGS += -D'CONFIG_JLINK_SPI=1'
658PROGRAMMER_OBJS += jlink_spi.o
659endif
660
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100661ifeq ($(CONFIG_NI845X_SPI), yes)
662FEATURE_CFLAGS += -D'CONFIG_NI845X_SPI=1'
663
664ifeq ($(CONFIG_NI845X_LIBRARY_PATH),)
665# if the user did not specified the NI-845x headers/lib path
666# do a guess for both 32 and 64 bit Windows versions
667NI845X_LIBS += -L'${PROGRAMFILES}\National Instruments\NI-845x\MS Visual C'
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100668NI845X_INCLUDES += -I'${PROGRAMFILES}\National Instruments\NI-845x\MS Visual C'
Miklós Mártonfea5aa12021-07-27 14:29:16 +0200669
670# hack to access env variable containing brackets...
671PROGRAMFILES_X86DIR = $(shell env | sed -n "s/^PROGRAMFILES(X86)=//p")
672
673ifneq ($(PROGRAMFILES_X86DIR),)
674ifneq ($(PROGRAMFILES_X86DIR), ${PROGRAMFILES})
675NI845X_LIBS += -L'$(PROGRAMFILES_X86DIR)\National Instruments\NI-845x\MS Visual C'
676NI845X_INCLUDES += -I'$(PROGRAMFILES_X86DIR)\National Instruments\NI-845x\MS Visual C'
677endif
678endif
679
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100680else
681NI845X_LIBS += -L'$(CONFIG_NI845X_LIBRARY_PATH)'
682NI845X_INCLUDES += -I'$(CONFIG_NI845X_LIBRARY_PATH)'
683endif
684
685FEATURE_CFLAGS += $(NI845X_INCLUDES)
686LIBS += -lni845x
687PROGRAMMER_OBJS += ni845x_spi.o
688endif
689
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000690ifneq ($(NEED_SERIAL), )
Thomas Heijligen140c1262021-09-27 15:12:26 +0200691LIB_OBJS += serial.o
692ifeq ($(TARGET_OS), Linux)
693LIB_OBJS += custom_baud_linux.o
694else
695LIB_OBJS += custom_baud.o
696endif
Carl-Daniel Hailfinger5bdf2982010-06-14 12:42:05 +0000697endif
698
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000699ifneq ($(NEED_POSIX_SOCKETS), )
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000700ifeq ($(TARGET_OS), SunOS)
Stefan Taunerfc3ecc22016-03-13 12:57:03 +0000701LIBS += -lsocket -lnsl
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000702endif
Carl-Daniel Hailfingere51ea102009-11-23 19:20:11 +0000703endif
704
Nico Huberf55ca202021-06-27 14:36:06 +0200705NEED_LIBPCI := $(call filter_deps,$(DEPENDS_ON_LIBPCI))
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000706ifneq ($(NEED_LIBPCI), )
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000707CHECK_LIBPCI = yes
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000708# This is a dirty hack, but it saves us from checking all PCI drivers and all platforms manually.
709# libpci may need raw memory, MSR or PCI port I/O on some platforms.
710# Individual drivers might have the same needs as well.
711NEED_RAW_ACCESS += $(NEED_LIBPCI)
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000712FEATURE_CFLAGS += -D'NEED_PCI=1'
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000713FEATURE_CFLAGS += $(call debug_shell,grep -q "OLD_PCI_GET_DEV := yes" .libdeps && printf "%s" "-D'OLD_PCI_GET_DEV=1'")
Stefan Tauner56734502015-02-08 21:58:04 +0000714
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000715PROGRAMMER_OBJS += pcidev.o
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000716ifeq ($(TARGET_OS), NetBSD)
Carl-Daniel Hailfinger460b2822010-06-04 23:24:57 +0000717# The libpci we want is called libpciutils on NetBSD and needs NetBSD libpci.
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000718PCILIBS += -lpciutils -lpci
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000719else
720PCILIBS += -lpci
721endif
722endif
723
724ifneq ($(NEED_RAW_ACCESS), )
725# Raw memory, MSR or PCI port I/O access.
726FEATURE_CFLAGS += -D'NEED_RAW_ACCESS=1'
727PROGRAMMER_OBJS += physmap.o hwaccess.o
728
729ifeq ($(TARGET_OS), NetBSD)
Nico Huber9245b882021-04-18 20:50:32 +0200730ifeq ($(ARCH), x86)
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000731PCILIBS += -l$(shell uname -p)
Nico Huber9245b882021-04-18 20:50:32 +0200732endif
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000733else
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000734ifeq ($(TARGET_OS), OpenBSD)
Nico Huber9245b882021-04-18 20:50:32 +0200735ifeq ($(ARCH), x86)
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000736PCILIBS += -l$(shell uname -m)
Nico Huber9245b882021-04-18 20:50:32 +0200737endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000738else
739ifeq ($(TARGET_OS), Darwin)
740# DirectHW framework can be found in the DirectHW library.
Stefan Taunere34e3e82013-01-01 00:06:51 +0000741PCILIBS += -framework IOKit -framework DirectHW
Carl-Daniel Hailfingerb63b0672010-07-02 17:12:50 +0000742endif
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000743endif
Jonathan A. Kollasch3646c8f2010-01-08 21:18:08 +0000744endif
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000745
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000746endif
747
Nico Huberf55ca202021-06-27 14:36:06 +0200748NEED_LIBUSB1 := $(call filter_deps,$(DEPENDS_ON_LIBUSB1))
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000749ifneq ($(NEED_LIBUSB1), )
Stefan Taunere49edbb2016-01-31 22:10:14 +0000750CHECK_LIBUSB1 = yes
Daniel Thompson1d507a02018-07-12 11:02:28 +0100751PROGRAMMER_OBJS += usbdev.o
Stefan Taunere49edbb2016-01-31 22:10:14 +0000752# FreeBSD and DragonflyBSD use a reimplementation of libusb-1.0 that is simply called libusb
753ifeq ($(TARGET_OS),$(filter $(TARGET_OS),FreeBSD DragonFlyBSD))
754USB1LIBS += -lusb
755else
756ifeq ($(TARGET_OS),NetBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000757override CPPFLAGS += -I/usr/pkg/include/libusb-1.0
Stefan Taunere49edbb2016-01-31 22:10:14 +0000758USB1LIBS += -lusb-1.0
759else
Stefan Tauner45207062016-02-19 08:17:24 +0000760USB1LIBS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --libs libusb-1.0 || printf "%s" "-lusb-1.0")
761override CPPFLAGS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --cflags-only-I libusb-1.0 || printf "%s" "-I/usr/include/libusb-1.0")
Stefan Taunere49edbb2016-01-31 22:10:14 +0000762endif
763endif
764endif
765
Nico Huberf55ca202021-06-27 14:36:06 +0200766NEED_LIBFTDI := $(call filter_deps,$(DEPENDS_ON_LIBFTDI))
Nico Huber09e82e22021-06-27 14:31:37 +0200767ifneq ($(NEED_LIBFTDI), )
768FTDILIBS := $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)" ; $(PKG_CONFIG) --libs libftdi1 || $(PKG_CONFIG) --libs libftdi || printf "%s" "-lftdi -lusb")
769FEATURE_CFLAGS += $(call debug_shell,grep -q "FT232H := yes" .features && printf "%s" "-D'HAVE_FT232H=1'")
770FTDI_INCLUDES := $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)" ; $(PKG_CONFIG) --cflags-only-I libftdi1)
771FEATURE_CFLAGS += $(FTDI_INCLUDES)
772FEATURE_LIBS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "$(FTDILIBS)")
773# We can't set NEED_LIBUSB1 here because that would transform libftdi auto-enabling
774# into a hard requirement for libusb, defeating the purpose of auto-enabling.
775endif
776
Nico Huberf55ca202021-06-27 14:36:06 +0200777NEED_LIBJAYLINK := $(call filter_deps,$(DEPENDS_ON_LIBJAYLINK))
Marc Schink3578ec62016-03-17 16:23:03 +0100778ifneq ($(NEED_LIBJAYLINK), )
779CHECK_LIBJAYLINK = yes
780JAYLINKLIBS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --libs libjaylink)
781override CPPFLAGS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --cflags-only-I libjaylink)
782endif
783
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +0000784ifeq ($(CONFIG_PRINT_WIKI), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000785FEATURE_CFLAGS += -D'CONFIG_PRINT_WIKI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000786CLI_OBJS += print_wiki.o
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +0000787endif
788
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000789FEATURE_CFLAGS += $(call debug_shell,grep -q "UTSNAME := yes" .features && printf "%s" "-D'HAVE_UTSNAME=1'")
Carl-Daniel Hailfinger132e2ec2010-03-27 16:36:40 +0000790
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000791# We could use PULLED_IN_LIBS, but that would be ugly.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000792FEATURE_LIBS += $(call debug_shell,grep -q "NEEDLIBZ := yes" .libdeps && printf "%s" "-lz")
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000793
Nico Huber8624e8c2012-11-05 21:46:33 +0100794FEATURE_CFLAGS += $(call debug_shell,grep -q "CLOCK_GETTIME := yes" .features && printf "%s" "-D'HAVE_CLOCK_GETTIME=1'")
795FEATURE_LIBS += $(call debug_shell,grep -q "CLOCK_GETTIME := yes" .features && printf "%s" "-lrt")
796
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000797LIBFLASHROM_OBJS = $(CHIP_OBJS) $(PROGRAMMER_OBJS) $(LIB_OBJS)
Stefan Taunerd94d25d2012-07-28 03:17:15 +0000798OBJS = $(CLI_OBJS) $(LIBFLASHROM_OBJS)
Sean Nelson5d134642009-12-24 16:54:21 +0000799
Joerg Mayera93d9dc2013-08-29 00:38:19 +0000800all: hwlibs features $(PROGRAM)$(EXEC_SUFFIX) $(PROGRAM).8
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000801ifeq ($(ARCH), x86)
802 @+$(MAKE) -C util/ich_descriptors_tool/ TARGET_OS=$(TARGET_OS) EXEC_SUFFIX=$(EXEC_SUFFIX)
803endif
804
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000805$(PROGRAM)$(EXEC_SUFFIX): $(OBJS)
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100806 $(CC) $(LDFLAGS) -o $(PROGRAM)$(EXEC_SUFFIX) $(OBJS) $(LIBS) $(PCILIBS) $(FEATURE_LIBS) $(USBLIBS) $(USB1LIBS) $(JAYLINKLIBS) $(NI845X_LIBS)
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +0000807
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000808libflashrom.a: $(LIBFLASHROM_OBJS)
809 $(AR) rcs $@ $^
810 $(RANLIB) $@
811
Carl-Daniel Hailfinger8ef7dce2009-07-10 20:19:48 +0000812# TAROPTIONS reduces information leakage from the packager's system.
813# If other tar programs support command line arguments for setting uid/gid of
814# stored files, they can be handled here as well.
815TAROPTIONS = $(shell LC_ALL=C tar --version|grep -q GNU && echo "--owner=root --group=root")
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +0000816
Paul Fox05dfbe62009-06-16 21:08:06 +0000817%.o: %.c .features
Stefan Tauner76347082016-11-27 17:45:49 +0100818 $(CC) -MMD $(CFLAGS) $(CPPFLAGS) $(FLASHROM_CFLAGS) $(FEATURE_CFLAGS) $(SCMDEF) -o $@ -c $<
Clark Rawlins02016f72008-02-14 23:22:20 +0000819
Carl-Daniel Hailfingera0020df2010-05-30 22:35:14 +0000820# Make sure to add all names of generated binaries here.
821# This includes all frontends and libflashrom.
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000822# We don't use EXEC_SUFFIX here because we want to clean everything.
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +0000823clean:
Thomas Heijligen1e76dc82021-09-28 15:22:34 +0200824 rm -f $(PROGRAM) $(PROGRAM).exe libflashrom.a $(filter-out Makefile.d, $(wildcard *.d *.o)) $(PROGRAM).8 $(PROGRAM).8.html $(BUILD_DETAILS_FILE)
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000825 @+$(MAKE) -C util/ich_descriptors_tool/ clean
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +0000826
Ollie Lho184a4042005-11-26 21:55:36 +0000827distclean: clean
Stefan Reinauere2f01582010-06-07 11:08:07 +0000828 rm -f .features .libdeps
Christian Ruppertdb9d9f42009-05-14 14:17:07 +0000829
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000830strip: $(PROGRAM)$(EXEC_SUFFIX)
831 $(STRIP) $(STRIP_ARGS) $(PROGRAM)$(EXEC_SUFFIX)
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +0000832
Stefan Tauner56787082011-08-18 02:27:19 +0000833# to define test programs we use verbatim variables, which get exported
834# to environment variables and are referenced with $$<varname> later
835
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +0000836compiler: featuresavailable
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000837 @printf "Checking for a C compiler... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +0000838 @echo "$$COMPILER_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000839 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .test.c -o .test$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000840 @{ { { { { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .test.c -o .test$(EXEC_SUFFIX) >&2 && \
841 echo "found." || { echo "not found."; \
842 rm -f .test.c .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000843 @rm -f .test.c .test$(EXEC_SUFFIX)
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000844 @printf "Target arch is "
Carl-Daniel Hailfinger91199a12011-07-07 06:59:18 +0000845 @# FreeBSD wc will output extraneous whitespace.
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000846 @echo $(ARCH)|wc -w|grep -q '^[[:blank:]]*1[[:blank:]]*$$' || \
Pyry Kontio89cc73b2020-07-06 12:57:35 +0900847 ( echo "unknown (\"$(ARCH)\"). Aborting."; exit 1)
Carl-Daniel Hailfinger91199a12011-07-07 06:59:18 +0000848 @printf "%s\n" '$(ARCH)'
Thomas Heijligen1e76dc82021-09-28 15:22:34 +0200849 @echo Target OS is $(TARGET_OS)
850 @if [ $(TARGET_OS) = unknown ]; then echo Aborting.; exit 1; fi
Stefan Taunerd6c17f62013-09-12 14:04:31 +0000851ifeq ($(TARGET_OS), libpayload)
852 @$(CC) --version 2>&1 | grep -q coreboot || \
853 ( echo "Warning: It seems you are not using coreboot's reference compiler."; \
854 echo "This might work but usually does not, please beware." )
855endif
Carl-Daniel Hailfinger4cb7a962009-06-16 09:31:51 +0000856
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000857hwlibs: compiler
858 @printf "" > .libdeps
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000859ifeq ($(CHECK_LIBPCI), yes)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000860 @printf "Checking for libpci headers... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +0000861 @echo "$$LIBPCI_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000862 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000863 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
864 echo "found." || { echo "not found."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000865 echo "The following features require libpci: $(NEED_LIBPCI)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +0000866 echo "Please install libpci headers or disable all features"; \
867 echo "mentioned above by specifying make CONFIG_ENABLE_LIBPCI_PROGRAMMERS=no"; \
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000868 echo "See README for more information."; echo; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000869 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
870 @printf "Checking version of pci_get_dev... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56734502015-02-08 21:58:04 +0000871 @echo "$$PCI_GET_DEV_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000872 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000873 @ { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
Stefan Tauner56734502015-02-08 21:58:04 +0000874 ( echo "new version (including PCI domain parameter)."; echo "OLD_PCI_GET_DEV := no" >> .libdeps ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000875 ( echo "old version (without PCI domain parameter)."; echo "OLD_PCI_GET_DEV := yes" >> .libdeps ) } 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
876 @printf "Checking if libpci is present and sufficient... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000877 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000878 @{ { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) 2>>$(BUILD_DETAILS_FILE) >&2 && \
879 echo "yes." || { echo "no."; \
880 printf "Checking if libz+libpci are present and sufficient..." ; \
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000881 { printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) -lz" >>$(BUILD_DETAILS_FILE) ; \
882 $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) -lz >&2 && \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000883 echo "yes." && echo "NEEDLIBZ := yes" > .libdeps } || { echo "no."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000884 echo "The following features require libpci: $(NEED_LIBPCI)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +0000885 echo "Please install libpci (package pciutils) and/or libz or disable all features"; \
886 echo "mentioned above by specifying make CONFIG_ENABLE_LIBPCI_PROGRAMMERS=no"; \
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000887 echo "See README for more information."; echo; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000888 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000889 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000890endif
Stefan Taunere49edbb2016-01-31 22:10:14 +0000891ifeq ($(CHECK_LIBUSB1), yes)
892 @printf "Checking for libusb-1.0 headers... " | tee -a $(BUILD_DETAILS_FILE)
893 @echo "$$LIBUSB1_TEST" > .test.c
894 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
895 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
896 echo "found." || { echo "not found."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000897 echo "The following features require libusb-1.0: $(NEED_LIBUSB1)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +0000898 echo "Please install libusb-1.0 headers or disable all features"; \
899 echo "mentioned above by specifying make CONFIG_ENABLE_LIBUSB1_PROGRAMMERS=no"; \
Stefan Taunere49edbb2016-01-31 22:10:14 +0000900 echo "See README for more information."; echo; \
901 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
902 @printf "Checking if libusb-1.0 is usable... " | tee -a $(BUILD_DETAILS_FILE)
903 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(USB1LIBS)" >>$(BUILD_DETAILS_FILE)
904 @{ { { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(USB1LIBS) >&2 && \
905 echo "yes." || { echo "no."; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000906 echo "The following features require libusb-1.0: $(NEED_LIBUSB1)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +0000907 echo "Please install libusb-1.0 or disable all features"; \
908 echo "mentioned above by specifying make CONFIG_ENABLE_LIBUSB1_PROGRAMMERS=no"; \
Stefan Taunere49edbb2016-01-31 22:10:14 +0000909 echo "See README for more information."; echo; \
910 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
911 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
912endif
Marc Schink3578ec62016-03-17 16:23:03 +0100913ifeq ($(CHECK_LIBJAYLINK), yes)
914 @printf "Checking for libjaylink headers... " | tee -a $(BUILD_DETAILS_FILE)
915 @echo "$$LIBJAYLINK_TEST" > .test.c
916 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
917 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
918 echo "found." || { echo "not found."; echo; \
919 echo "The following feature requires libjaylink: $(NEED_LIBJAYLINK)."; \
920 echo "Please install libjaylink headers or disable the feature"; \
921 echo "mentioned above by specifying make CONFIG_JLINK_SPI=no"; \
922 echo "See README for more information."; echo; \
923 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
924 @printf "Checking if libjaylink is usable... " | tee -a $(BUILD_DETAILS_FILE)
925 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(JAYLINKLIBS)" >>$(BUILD_DETAILS_FILE)
926 @{ { { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(JAYLINKLIBS) >&2 && \
927 echo "yes." || { echo "no."; \
928 echo "The following feature requires libjaylink: $(NEED_LIBJAYLINK)."; \
929 echo "Please install libjaylink or disable the feature"; \
930 echo "mentioned above by specifying make CONFIG_JLINK_SPI=no"; \
931 echo "See README for more information."; echo; \
932 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
933 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
934endif
Stefan Reinauer53e96252005-12-01 16:19:24 +0000935
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +0000936.features: features
937
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +0000938# If a user does not explicitly request a non-working feature, we should
939# silently disable it. However, if a non-working (does not compile) feature
940# is explicitly requested, we should bail out with a descriptive error message.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000941# We also have to check that at least one programmer driver is enabled.
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +0000942featuresavailable:
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000943ifeq ($(PROGRAMMER_OBJS),)
944 @echo "You have to enable at least one programmer driver!"
945 @false
946endif
947ifneq ($(UNSUPPORTED_FEATURES), )
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +0000948 @echo "The following features are unavailable on your machine: $(UNSUPPORTED_FEATURES)"
949 @false
950endif
951
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +0000952features: compiler
953 @echo "FEATURES := yes" > .features.tmp
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000954ifneq ($(NEED_LIBFTDI), )
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000955 @printf "Checking for FTDI support... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +0000956 @echo "$$FTDI_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000957 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000958 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS) >&2 && \
959 ( echo "found."; echo "FTDISUPPORT := yes" >> .features.tmp ; \
960 printf "Checking for FT232H support in libftdi... " ; \
961 echo "$$FTDI_232H_TEST" >> .featuretest.c ; \
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000962 printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS)" >>$(BUILD_DETAILS_FILE) ; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000963 { $(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS) >&2 && \
964 ( echo "found."; echo "FT232H := yes" >> .features.tmp ) || \
965 ( echo "not found."; echo "FT232H := no" >> .features.tmp ) } \
966 ) || \
967 ( echo "not found."; echo "FTDISUPPORT := no" >> .features.tmp ) } \
968 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Carl-Daniel Hailfinger8a59ff02009-12-24 03:33:11 +0000969endif
David Hendricksf9a30552015-05-23 20:30:30 -0700970ifeq ($(CONFIG_LINUX_MTD), yes)
971 @printf "Checking if Linux MTD headers are present... " | tee -a $(BUILD_DETAILS_FILE)
972 @echo "$$LINUX_MTD_TEST" > .featuretest.c
973 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
974 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
975 ( echo "yes."; echo "LINUX_MTD_SUPPORT := yes" >> .features.tmp ) || \
976 ( echo "no."; echo "LINUX_MTD_SUPPORT := no" >> .features.tmp ) } \
977 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
978endif
Stefan Tauner8868db32012-03-13 00:18:19 +0000979ifeq ($(CONFIG_LINUX_SPI), yes)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000980 @printf "Checking if Linux SPI headers are present... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner8868db32012-03-13 00:18:19 +0000981 @echo "$$LINUX_SPI_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000982 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000983 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Stefan Tauner8868db32012-03-13 00:18:19 +0000984 ( echo "yes."; echo "LINUX_SPI_SUPPORT := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000985 ( echo "no."; echo "LINUX_SPI_SUPPORT := no" >> .features.tmp ) } \
986 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner8868db32012-03-13 00:18:19 +0000987endif
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000988ifneq ($(NEED_LINUX_I2C), )
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000989 @printf "Checking if Linux I2C headers are present... " | tee -a $(BUILD_DETAILS_FILE)
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000990 @echo "$$LINUX_I2C_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000991 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000992 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000993 ( echo "yes."; echo "LINUX_I2C_SUPPORT := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000994 ( echo "no."; echo "LINUX_I2C_SUPPORT := no" >> .features.tmp ) } \
995 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000996endif
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100997ifeq ($(CONFIG_NI845X_SPI), yes)
998 @printf "Checking for NI USB-845x installation... " | tee -a $(BUILD_DETAILS_FILE)
999 @echo "$$NI845X_TEST" > .featuretest.c
1000 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(NI845X_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(NI845X_LIBS) $(LIBS)" >>$(BUILD_DETAILS_FILE)
1001
1002 @ { { { { { $(CC) $(CPPFLAGS) $(CFLAGS) $(NI845X_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(NI845X_LIBS) $(LIBS) >&2 && \
1003 ( echo "yes."; echo "NI845X_SUPPORT := yes" >> .features.tmp ) || \
1004 { echo -e "\nUnable to find NI-845x headers or libraries."; \
1005 echo "Please pass the NI-845x library path to the make with the CONFIG_NI845X_LIBRARY_PATH parameter,"; \
1006 echo "or disable the NI-845x support by specifying make CONFIG_NI845X_SPI=no"; \
1007 echo "For the NI-845x 17.0 the library path is:"; \
1008 echo " On 32 bit systems: C:\Program Files)\National Instruments\NI-845x\MS Visual C"; \
1009 echo " On 64 bit systems: C:\Program Files (x86)\National Instruments\NI-845x\MS Visual C"; \
1010 exit 1; }; } \
1011 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1012endif
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001013 @printf "Checking for utsname support... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +00001014 @echo "$$UTSNAME_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001015 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001016 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Stefan Tauner56787082011-08-18 02:27:19 +00001017 ( echo "found."; echo "UTSNAME := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001018 ( echo "not found."; echo "UTSNAME := no" >> .features.tmp ) } 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Nico Huber8624e8c2012-11-05 21:46:33 +01001019 @printf "Checking for clock_gettime support... " | tee -a $(BUILD_DETAILS_FILE)
Martin Lucinac14e3f62020-12-18 14:11:04 +00001020ifeq ($(DISABLE_CLOCK_GETTIME), yes)
1021 @ { ( echo "disabled."; echo "CLOCK_GETTIME := no" >>.features.tmp ) } \
1022 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
1023else
Nico Huber8624e8c2012-11-05 21:46:33 +01001024 @echo "$$CLOCK_GETTIME_TEST" >.featuretest.c
1025 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -lrt .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
1026 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -lrt .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
1027 ( echo "found."; echo "CLOCK_GETTIME := yes" >>.features.tmp ) || \
1028 ( echo "not found."; echo "CLOCK_GETTIME := no" >>.features.tmp ) } \
1029 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Martin Lucinac14e3f62020-12-18 14:11:04 +00001030endif
Stefan Tauner56787082011-08-18 02:27:19 +00001031 @$(DIFF) -q .features.tmp .features >/dev/null 2>&1 && rm .features.tmp || mv .features.tmp .features
1032 @rm -f .featuretest.c .featuretest$(EXEC_SUFFIX)
Paul Fox05dfbe62009-06-16 21:08:06 +00001033
Stefan Tauner4c723152016-01-14 22:47:55 +00001034$(PROGRAM).8.html: $(PROGRAM).8
1035 @groff -mandoc -Thtml $< >$@
1036
Joerg Mayera93d9dc2013-08-29 00:38:19 +00001037$(PROGRAM).8: $(PROGRAM).8.tmpl
Stefan Tauner4c723152016-01-14 22:47:55 +00001038 @# Add the man page change date and version to the man page
Nico Huberac90af62022-12-18 00:22:47 +00001039 @sed -e 's#.TH FLASHROM 8 .*#.TH FLASHROM 8 "$(MAN_DATE)" "flashrom-stable-$(VERSION)" "$(MAN_DATE)"#' <$< >$@
Joerg Mayera93d9dc2013-08-29 00:38:19 +00001040
1041install: $(PROGRAM)$(EXEC_SUFFIX) $(PROGRAM).8
Uwe Hermannc2a9c9c2009-05-14 14:51:14 +00001042 mkdir -p $(DESTDIR)$(PREFIX)/sbin
Uwe Hermann56b2cb02009-05-21 15:59:58 +00001043 mkdir -p $(DESTDIR)$(MANDIR)/man8
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +00001044 $(INSTALL) -m 0755 $(PROGRAM)$(EXEC_SUFFIX) $(DESTDIR)$(PREFIX)/sbin
Uwe Hermann56b2cb02009-05-21 15:59:58 +00001045 $(INSTALL) -m 0644 $(PROGRAM).8 $(DESTDIR)$(MANDIR)/man8
Uwe Hermannc113b572006-12-14 00:59:41 +00001046
Nico Huber454f6132012-12-10 13:34:10 +00001047libinstall: libflashrom.a libflashrom.h
1048 mkdir -p $(DESTDIR)$(PREFIX)/lib
1049 $(INSTALL) -m 0644 libflashrom.a $(DESTDIR)$(PREFIX)/lib
1050 mkdir -p $(DESTDIR)$(PREFIX)/include
1051 $(INSTALL) -m 0644 libflashrom.h $(DESTDIR)$(PREFIX)/include
1052
Nico Huber5f245a22023-01-10 17:14:47 +01001053versioninfo:
1054# Generate versioninfo.inc containing metadata that would not be available in exported sources otherwise.
1055 @[ "$(RELEASE)" ] || { echo 'Error: Must provide `RELEASE=...`'; exit 1; }
1056 @echo "VERSION = $(RELEASE)" > $@.inc
1057 @echo "MAN_DATE = $(shell ./util/getrevision.sh --date $(PROGRAM).8.tmpl 2>/dev/null)" >> $@.inc
1058
Nico Huber26c2c4d2023-01-10 17:45:38 +01001059branch: versioninfo
1060 @git checkout -b $(RELEASE)
1061 @git add -f $<.inc
1062 @git commit -sm'Update version info for $(RELEASE)'
1063
1064tag: versioninfo
1065 @git add -f $<.inc
1066 @git commit -sm'Update version info for $(RELEASE)'
1067 @git tag -s $(RELEASE)
1068
Nico Huber5f245a22023-01-10 17:14:47 +01001069# No spaces in release names unless set explicitly
Nico Huber1d58a902023-01-10 18:26:12 +01001070RELEASENAME ?= flashrom-stable-$(shell echo "$(VERSION)" | sed -e 's/ /_/')
Nico Huber5f245a22023-01-10 17:14:47 +01001071
Nico Huber1d58a902023-01-10 18:26:12 +01001072_export: EXPORT_VERSIONINFO := $(EXPORTDIR)/$(RELEASENAME)/versioninfo.inc
Stefan Tauner76347082016-11-27 17:45:49 +01001073_export: $(PROGRAM).8
Nico Huber1d58a902023-01-10 18:26:12 +01001074 @rm -rf "$(EXPORTDIR)/$(RELEASENAME)"
1075 @mkdir -p "$(EXPORTDIR)/$(RELEASENAME)"
1076 @git archive HEAD | tar -x -C "$(EXPORTDIR)/$(RELEASENAME)"
Nico Huber5f245a22023-01-10 17:14:47 +01001077# Generate fresh versioninfo.inc and compare
1078 @echo "VERSION = $(shell ./util/getrevision.sh --revision)" > "$(EXPORT_VERSIONINFO)"
1079 @echo "MAN_DATE = $(shell ./util/getrevision.sh --date $(PROGRAM).8.tmpl 2>/dev/null)" >> \
1080 "$(EXPORT_VERSIONINFO)"
1081 @if [ -f versioninfo.inc ]; then \
1082 cmp -s versioninfo.inc "$(EXPORT_VERSIONINFO)" || \
1083 { echo Error: Version info changed:; \
1084 cat "$(EXPORT_VERSIONINFO)"; \
1085 echo Update versioninfo.inc and tag accordingly.; \
1086 exit 1; \
1087 }; \
1088 fi
Stefan Taunere4136852017-10-01 15:57:25 +02001089# Restore modification date of all tracked files not marked 'export-ignore' in .gitattributes.
1090# sed is required to filter out file names having the attribute set.
1091# The sed program saves the file name in the hold buffer and then checks if the respective value is 'set'.
1092# If so it ignores the rest of the program, which otherwise restores the file name and prints it.
Stefan Tauner76347082016-11-27 17:45:49 +01001093 @git ls-tree -r -z -t --full-name --name-only HEAD | \
1094 git check-attr -z --stdin export-ignore | \
Stefan Taunere4136852017-10-01 15:57:25 +02001095 sed -zne 'x;n;n;{/^set$$/b;};x;p;' | \
Stefan Tauner76347082016-11-27 17:45:49 +01001096 xargs -0 sh -c 'for f; do \
1097 touch -d $$(git log --pretty=format:%cI -1 HEAD -- "$$f") \
Nico Huber1d58a902023-01-10 18:26:12 +01001098 "$(EXPORTDIR)/$(RELEASENAME)/$$f"; \
Stefan Taunere4136852017-10-01 15:57:25 +02001099 done' dummy_arg0
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +00001100
Stefan Tauner76347082016-11-27 17:45:49 +01001101export: _export
Nico Huber1d58a902023-01-10 18:26:12 +01001102 @echo "Exported $(EXPORTDIR)/$(RELEASENAME)/"
Stefan Tauner76347082016-11-27 17:45:49 +01001103
1104tarball: _export
Nico Huber1d58a902023-01-10 18:26:12 +01001105 @tar -cj --format=ustar -f "$(EXPORTDIR)/$(RELEASENAME).tar.bz2" -C $(EXPORTDIR)/ \
1106 $(TAROPTIONS) "$(RELEASENAME)/"
Stefan Tauner76347082016-11-27 17:45:49 +01001107# Delete the exported directory again because it is most likely what's expected by the user.
Nico Huber1d58a902023-01-10 18:26:12 +01001108 @rm -rf "$(EXPORTDIR)/$(RELEASENAME)"
1109 @echo Created "$(EXPORTDIR)/$(RELEASENAME).tar.bz2"
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +00001110
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +00001111libpayload: clean
1112 make CC="CC=i386-elf-gcc lpgcc" AR=i386-elf-ar RANLIB=i386-elf-ranlib
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +00001113
Felix Singer9441c6e2022-10-21 12:47:11 +02001114gitconfig:
1115 ./util/getrevision.sh -c 2>/dev/null && ./util/git-hooks/install.sh
1116
Nico Huber26c2c4d2023-01-10 17:45:38 +01001117.PHONY: all install clean distclean compiler hwlibs features branch tag versioninfo _export export tarball featuresavailable libpayload gitconfig
Ollie Lho184a4042005-11-26 21:55:36 +00001118
Stefan Tauner23e10b82016-01-23 16:16:49 +00001119# Disable implicit suffixes and built-in rules (for performance and profit)
1120.SUFFIXES:
1121
Stefan Reinauere2f01582010-06-07 11:08:07 +00001122-include $(OBJS:.o=.d)